README for Windbg Copilot

Windbg Copilot is a ChatGPT powered AI assistant directly in Windbg. It analyzes the output of the commands, and provides guidance to solve the stated problem.

Prerequisites

        1. Operating System: Windows 11
        2. If you want to use OpenAI API, add environmet variable OPENAI_API_KEY = <openai api key>
        3. If you want to use Azure OpenAI, add following environment variables:
                AZURE_OPENAI_ENDPOINT = <Azure OpenAI Endpoint>
                AZURE_OPENAI_KEY = <Azure OpenAI Key>
                AZURE_OPENAI_DEPLOYMENT = <Azure OpenAI Deployment Name>
        4. The Windows Debugger (Windbg) installed on your machine, for example: C:\Program Files\Debugging Tools for Windows (x64)
           Add environment variable WINDBG_PATH = C:\Program Files\Debugging Tools for Windows (x64).
        6. Add environment variable _NT_SYMBOL_PATH = srv*c:\symbols*https://msdl.microsoft.com/download/symbols
        7. Python 3.9 or later installed on your machine.
        8. An Internet connection for downloading and installing the package.

Installation

        Open a command prompt or terminal window, install the Windbg Copilot package using pip:

                pip install windbg_copilot

        The packages will be downloaded and installed automatically.

Usage

        Open your Python environment or editor and enter the following command:

                import windbg_copilot

        The given commands are used to interact with Windbg Copilot, a tool that utilizes the OpenAI model for assistance with debugging. The commands include:

                !on: Enables chat mode, where inputs and outputs are sent to the OpenAI model.
                !off: Disables chat mode, allowing inputs to be sent directly to the debugger and outputs to be received from the OpenAI model.
                !p <problem statement>: Updates the problem description by providing a new problem statement.
                !quit or !q or q or qq: Terminates the debugger session.
                !help or !h: Provides help information.

        Note: Windbg Copilot requires an active Internet connection to function properly, as it relies on Openai API.

Uninstallation

        Open a command prompt or terminal window.
        Use pip to uninstall the Windbg Copilot package:

                pip uninstall windbg_copilot

        The packages will be uninstalled automatically.